extern void *early_memremap_prot(resource_size_t phys_addr,
				 unsigned long size, unsigned long prot_val);
extern void early_iounmap(void __iomem *addr, unsigned long size);
#ifdef CONFIG_PTP
extern void early_iounmap_after_init(void __iomem *addr, unsigned long size);
#endif
extern void early_memunmap(void *addr, unsigned long size);

#if defined(CONFIG_GENERIC_EARLY_IOREMAP) && defined(CONFIG_MMU)
/* Arch-specific initialization */
extern void early_ioremap_init(void);